"""
#///////////////////////////////////
    Author: Saimon
    Email: saimoncse19@gmail.com
    Dated: April 8, 2019
#//////////////////////////////////
"""

from bltk.langtools.banglachars import punctuations

sw1 = {'এ', 'হয়', 'কি', 'কী', 'না', 'এর', 'কে', 'যে', 'এই', 'বা', 'সব', 'টি', 'তা',
       'সে', 'তাই', 'সেই', 'তার', 'আগে', 'যদি', 'আছে', 'আমি', 'এবং', 'করে', 'কার', 'এটি', 'হতে', 'যায়',
       'আরও', 'যাক', 'খুব', 'উপর', 'পরে', 'হবে', 'কেন', 'নেই', 'কখন', 'সকল', 'হয়', 'ঠিক', 'একই', 'কোন',
       'ছিল', 'খুবই', 'কোনো', 'অধীন', 'যারা', 'তারা', 'গুলি', 'তাকে', 'সেটা', 'সময়', 'আমার', 'আমরা', 'সবার',
       'উভয়', 'একটা', 'আপনি', 'নিয়ে', 'একটি', 'বন্ধ', 'জন্য', 'শুধু', 'যেটা', 'উচিত', 'মাঝে', 'থেকে', 'করবে',
       'আবার', 'উপরে', 'সেটি', 'কিছু', 'কারণ', 'যেমন', 'তিনি', 'মধ্যে', 'আমাকে', 'করছেন', 'তুলনা', 'তারপর',
       'নিজেই', 'থাকার', 'নিজের', 'পারেন', 'একবার', 'সঙ্গে', 'ইচ্ছা', 'নীচের', 'এগুলো', 'আপনার', 'অধীনে', 'কিংবা',
       'এখানে', 'তাহলে', 'কয়েক', 'জন্যে', 'হচ্ছে', 'তাদের', 'কোথায়', 'কিন্তু', 'নিজেকে', 'যতক্ষণ', 'আমাদের',
       'দ্বারা', 'হয়েছে', ' সঙ্গে', 'সেখানে', 'কিভাবে', 'মাধ্যমে', 'নিজেদের', 'তুলনায়', 'প্রতিটি',
       'তাদেরকে', 'ইত্যাদি', 'সম্পর্কে', 'সর্বাধিক', 'বিরুদ্ধে', 'অন্যান্য'}

sw2 = {
       'আমাদের', 'কবে', 'হয়েছে', 'পর', 'রকম', 'ছিলেন', 'তিনিও', 'ধরা', 'ঐ', 'অবধি', 'কী',
       'ভাবেই', 'যাঁরা', 'অথবা','জানিয়ে', 'তাহাতে', 'কোনো', 'খুব', 'প্রতি', 'কয়েক', 'তাও', 'তাহা', 'প্রযন্ত',
       'জনকে', 'তবে', 'কিংবা', 'অথচ',
       'সমস্ত', 'থাকবেন', 'অন্তত', 'তত', 'ছাড়া', 'মাধ্যমে', 'হল', 'করবেন', 'চেয়ে', 'বিশেষ', 'এমনকী', 'তোমার',
       'ব্যাপারে', 'বি', 'আরও', 'থাকা', 'জানানো', 'ইহা', 'দিতে', 'এসে', 'হইয়া', 'জ্নজন', 'পি', 'এখন', 'টি',
       'সেটি', 'বন', 'নিয়ে', 'তারপর', 'জানতে', 'পাচ', 'এদের', 'জানায়', 'করিয়া', 'সহ', 'বলতে', 'আগামী', 'তাদের',
       'দেখে', 'নিয়ে', 'রেখে', 'গিয়ে', 'কেন', 'ই', 'রাখা', 'হাজার', 'তারৈ', 'কত', 'পরেই', 'নাই', 'নেই', 'আজ',
       'থেকেই', 'হওয়ার', 'হয়েছিল', 'সেটাও', 'উচিত', 'দুটি', 'আমি', 'নেওয়া', 'যত', 'হয়তো', 'যেখানে', 'আমরা', 'তেমন',
       'হয়নি', 'দুই', 'থাকায়', 'করি', 'সামনে', 'সেটাই', 'ব্যবহার', 'ধরে', 'সেই', 'দিয়েছে', 'শুধু', 'নাগাদ', 'কাজ',
       'অনেকে', 'আপনি', 'পারি', 'এখানে', 'বরং', 'তুলে', 'কারও', 'যাদের', 'যেন', 'করছেন', 'ওঁদের', 'বলে', 'দেয়', 'হলেই',
       'আমাকে', 'থেকে', 'তাঁকে', 'হইবে', 'জানা', 'দেওয়ার', 'ভাবে', 'তখন', 'ওরা', 'অনুযায়ী', 'হয়েই', 'কিন্তু', 'হলে', 'সম্প্রতি',
       'করায়', 'প্রথম', 'নিজে', 'এমনি', 'ছিল', 'হয়', 'তো', 'হওয়া', 'গেছে', 'বহু', 'বেশি', 'মনে', 'নিজেই', 'স্পষ্ট',
       'হওয়ায়', 'চার', 'বললেন', 'আবার', 'বদলে', 'হন', 'চায়', 'দিকে', 'কোনও', 'এটা', 'যারা', 'করবে', 'দেখতে', 'গেল',
       'তাহলে', 'এ', 'গিয়েছে', 'যথেষ্ট', 'শুরু', 'কয়েকটি', 'রয়েছে', 'বাদে', 'ইত্যাদি', 'এখানেই', 'চলে', 'প্রায়',
       'বলল', 'আই', 'যদি', 'হতেই', 'গোটা', 'কয়েক', 'জন', 'করেই', 'বিনা', 'পেয়্র্', 'মতোই', 'এই', 'এর', 'হয়',
       'বলেন', 'সেখান', 'করলে', 'তাকে', 'করেছিলেন', 'হত', 'বিষয়টি', 'আগে', 'কাছে', 'দেখা', 'কোটি', 'হলো', 'এবার',
       'মধ্যেও', 'সঙ্গেও', 'এমন', 'পারে', 'করেছেন', 'দিন', 'সি', 'বার', 'বক্তব্য', 'যেমন', 'মধ্যেই', 'এল', 'যার',
       'দেওয়া', 'পাওয়া', 'তুমি', 'হবেন', 'ওঁর', 'পর্যন্ত', 'এব', 'অর্থাত', 'জন্যওজে', 'প্রভৃতি', 'যখন', 'করিয়ে',
       'দিয়ে', 'করছে', 'হলেও', 'হবে', 'করার', 'প্রাথমিক', 'কাজে', 'উনি', 'থাকে', 'নয়', 'পেয়ে', 'আর', 'দ্বারা',
       'নিতে', 'না', 'কেউ', 'ঠিক', 'হয়েছেন', 'ও', 'হইতে', 'র', 'উপর', 'যাবে', 'পরেও', 'দু', 'কে', 'দেওয়া', 'হিসাবে',
       'এতটাই', 'এঁদের', 'নাকি', 'উত্তর', 'তাহার', 'এখনও', 'যে', 'হতে', 'নয়', 'হচ্ছে', 'অবশ্য', 'জনের', 'করাই', 'একটি',
       'তা', 'হয়ে', 'করে', 'তিনি', 'ফলে', 'এবং', 'মধ্যে', 'ছাড়াও', 'ফিরে', 'আদ্যভাগে', 'নিজের', 'এতে',
       'যাওয়া', 'এঁরা', 'সেখানে', 'হোক', 'সে', 'কিছু', 'চেষ্টা', 'দেন', 'কোন', 'মধ্যভাগে', 'ওর', 'নেওয়ার', 'কি',
       'গিয়ে', 'সঙ্গে', 'তাই', 'যাঁর', 'যদিও', 'ক্ষেত্রে', 'যাচ্ছে', 'তাঁর', 'এটি', 'চালু', 'তথা', 'দিলেন', 'আগেই',
       'করতে', 'কাছ', 'তার', 'ওদের', 'থাকেন', 'বলা', 'স্বয়ং', 'যায়', 'কাউকে', 'সেটা', 'অনেকেই', 'অনেক', 'ওখানে',
       'জন্য', 'থাকবে', 'এক্', 'সহিত', 'উপরে', 'তাঁদের', 'বলেছেন', 'যাওয়া', 'যান', 'নতুন', 'করিতে', 'দিয়েছেন',
       'মাত্র', 'যা', 'কেউই', 'জানিয়েছে', 'যিনি', 'পারেন', 'সাধারণ', 'করেন', 'বেশ', 'পক্ষে', 'একে', 'সবার', 'এত',
       'গেলে', 'লক্ষ', 'করা', 'যাকে', 'যাতে', 'তাতে', 'নেওয়া', 'থেকেও', 'নিজেদের', 'মোটেই', 'যতটা', 'অন্য', 'কমনে',
       'প্রায়', 'ফের', 'যেতে', 'জে', 'ওকে', 'কখনও', 'চান', 'এরা', 'নানা', 'তাঁাহারা', 'মোট', 'তারা', 'যাওয়ার', 'এস',
       'আপনার', 'তাঁরা', 'একবার', 'ওই', 'ধামার', 'সুতরাং', 'একই', 'বসে', 'অতএব', 'বিভিন্ন', 'তবু', 'কারণ', 'করেছে',
       'পরে', 'গুলি', 'কিছুই', 'তিনঐ', 'এটাই', 'আমার', 'মতো', 'ওঁরা', 'আছে', 'করলেন', 'হৈলে', 'কেখা', 'সব', 'দুটো',
       'বা'
       }


sw3 = {
       'সমস্ত', 'ছাড়া', 'যথেষ্ট', 'দুই', 'র', 'তারা', 'পরে', 'তার', 'করাই', 'ঐ', 'নিজেদের', 'মাঝে', 'নেই', 'আপনার',
       'দেখা', 'সেটাই', 'যাকে', 'প্রায়', 'গুলি', 'মাধ্যমে', 'কয়েকটি', 'নেওয়া', 'অথবা', 'বলেছেন', 'ঠিক', 'ফিরে',
       'নেওয়া', 'করার', 'আমি', 'ওরা', 'প্রতি', 'গিয়ে', 'কোটি', 'দেওয়ার', 'তাঁাহারা', 'প্রতিটি', 'যেন', 'করেন',
       'থাকবে', 'যায়', 'ওর', 'ইত্যাদি', 'বিষয়টি', 'এল', 'জনকে', 'পারি', 'যান', 'হলেও', 'কয়েক', 'যেতে', 'সঙ্গেও',
       'ফের', 'দেখে', 'বক্তব্য', 'আর', 'কিছু', 'একবার', 'বার', 'যায়', 'একটা', 'অন্যান্য', 'স্পষ্ট', 'হিসাবে', 'তাদের',
       'ওঁদের', 'সব', 'যে', 'কারও', 'করে', 'কেন', 'এর', 'টি', 'ওই', 'এই', 'করিতে', 'যেমন', 'দিলেন', 'তা', 'কার',
       'তেমন', 'পেয়ে', 'এমন', 'আদ্যভাগে', 'কিভাবে', 'জানায়', 'যা', 'উচিত', 'হচ্ছে', 'কোন', 'আমার', 'প্রথম', 'ই',
       'একে', 'সেই', 'এ', 'জনের', 'হয়েছে', 'করেছেন', 'দিন', 'কত', 'তাঁরা', 'কেখা', 'হয়ে', 'এবার', 'দিতে', 'ধরা',
       'থেকেও', 'ইহা', 'হইবে', 'করলে', 'সেটা', 'উপরে', 'হোক', 'আগামী', 'কখনও', 'কাছ', 'যেখানে', 'মোটেই', 'বললেন',
       'তাহাতে', 'নীচের', 'জে', 'হতে', 'কোনো', 'করায়', 'এব', 'বেশি', 'থাকার', 'নিজেই', 'তথা', 'যাক', 'হয়েছেন',
       'নেওয়ার', 'অধীনে', 'হয়েছিল', 'জন্যওজে', 'তাহলে', 'বন', 'হওয়া', 'পর্যন্ত', 'হতেই', 'হয়', 'অর্থাত', 'কিংবা',
       'তাহার', 'আমরা', 'নাই', 'বা', 'তুলনায়', 'নয়', 'এরা', 'পরেই', 'ছাড়াও', 'যারা', 'রয়েছে', 'অনেকে', ' সঙ্গে',
       'শুরু', 'সবার', 'ব্যবহার', 'কি', 'করবে', 'দুটি', 'মনে', 'তাঁদের', 'আবার', 'হয়তো', 'উত্তর', 'অন', 'যাওয়ার',
       'নিজের', 'জানতে', 'হইতে', 'হত', 'হওয়ার', 'তাদেরকে', 'চেয়ে', 'পেয়্র্', 'হৈলে', 'যাবে', 'বাদে', 'নাগাদ',
       'যাচ্ছে', 'নয়', 'রকম', 'ইচ্ছা', 'জানা', 'তারপর', 'এঁদের', 'নিজে', 'আগে', 'একটি', 'জানানো', 'দেয়', 'আরও',
       'তোমার', 'অনেকেই', 'এত', 'তবে', 'কাছে', 'সেখান', 'দুটো', 'সাধারণ', 'পারেন', 'করছেন', 'ব্যাপারে', 'যখন',
       'বিরুদ্ধে', 'আপনি', 'পরেও', 'হলেই', 'ছিলেন', 'গেলে', 'উপর', 'বিভিন্ন', 'তাকে', 'হয়নি', 'এমনি', 'থাকায়', 'মোট',
       'করতে পারেন', 'মধ্যভাগে', 'পাচ', 'কয়েক', 'যার', 'আছে', 'যদি', 'চায়', 'বদলে', 'সেটি', 'সেখানে', 'করেছে', 'তুলনা',
       'নিয়ে', 'যাওয়া', 'অনেক', 'যাতে', 'মাত্র', 'হয়', 'তিনিও', 'হন', 'স্বয়ং', 'গেল', 'চালু', 'করি', 'হল', 'তো',
       'সময়', 'আই', 'উভয়', 'উনি', 'দেওয়া', 'দেওয়া', 'তাই', 'তুমি', 'অবশ্য', 'কাউকে', 'লক্ষ', 'এস', 'পাওয়া', 'গোটা',
       'কখন', 'করেই', 'বিশেষ', 'জন্য', 'করিয়া', 'নানা', 'এটা', 'এসে', 'তিনি', 'তখন', 'অন্য', 'এবং', 'ওখানে', 'জন্যে',
       'গিয়েছে', 'না', 'তত', 'সঙ্গে', 'করবেন', 'অন্তত', 'কেউই', 'করিয়ে', 'সুতরাং', 'দু', 'কাজ', 'পর', 'ওকে', 'যদিও',
       'বি', 'জন', 'অবধি', 'নিজেকে', 'থেকে', 'অতএব', 'ওঁর', 'এখনও', 'ছিল', 'সে', 'ফলে', 'ধামার', 'একই', 'কী', 'কিন্তু',
       'হওয়ায়', 'গেছে', 'হইয়া', 'তবু', 'তারৈ', 'এটাই', 'এতে', 'এটি', 'মধ্যেই', 'বিনা', 'করলেন', 'ভাবেই', 'দেখতে',
       'তাঁকে', 'বেশ', 'থেকেই', 'সকল', 'চেষ্টা', 'বরং', 'ওদের', 'হবেন', 'নাকি', 'হাজার', 'ধরে', 'ও', 'বসে', 'অনুযায়ী',
       'অধীন', 'দিয়েছেন', 'নতুন', 'এখানেই', 'এঁরা', 'সহ', 'আমাদের', 'নিতে', 'হলে', 'জানিয়েছে', 'আজ', 'নিয়ে',
       'সর্বাধিক', 'থাকবেন', 'তাও', 'এদের', 'যাঁরা', 'হলো', 'করা', 'পারে', 'পি', 'খুব', 'বলেন', 'থাকে', 'প্রযন্ত',
       'সামনে', 'প্রাথমিক', 'তিনঐ', 'যতটা', 'জ্নজন', 'গিয়ে', 'করেছিলেন', 'ভাবে', 'শুধু', 'যাদের', 'বলা', 'রেখে',
       'কোনও', 'এগুলো', 'থাকেন', 'ক্ষেত্রে', 'রাখা', 'আপ', 'মধ্যেও', 'সম্প্রতি', 'এক্', 'কে', 'কবে', 'তাহা', 'কোথায়',
       'থাকা', 'তাতে', 'যাওয়া', 'বলতে', 'দেন', 'দিকে', 'সি', 'কমনে', 'কারণ', 'সম্পর্কে', 'ওঁরা', 'সেটাও', 'মতো',
       'জানিয়ে', 'বলে', 'তুলে', 'যেটা', 'দিয়ে', 'কিছুই', 'পক্ষে', 'মতোই', 'কাজে', 'সহিত', 'প্রভৃতি', 'করছে', 'অথচ',
       'বহু', 'এখানে', 'এতটাই', 'তাঁর', 'বন্ধ', 'করতে', 'যতক্ষণ', 'কেউ', 'খুবই', 'চান', 'চলে', 'যিনি', 'দিয়েছে',
       'বলল', 'এখন', 'চার', 'মধ্যে', 'এমনকী', 'দ্বারা', 'প্রায়', 'আগেই', 'হবে', 'যাঁর', 'আমাকে', 'যত', 'হয়েই'
}


def remove_stopwords(words: list, *,  level: str = "soft"):
    """
    :author : Saimon
    :param words: takes a list of words from which stop words will be eliminated,
    The text has to be tokenized by words before passing to the "words" parameter of the
    remove_stopwords function.
    :param level: indicates the degree of elimination of stop words
                    takes either "soft", "moderate" or "hard".
                    Default is soft.
    :return: returns a list after removing stop words.
    """

    new_words = []
    if level == "soft":
        for i in words:
            if i in sw1 or i in punctuations:
                del i
            else:
                new_words.append(i)
        return new_words

    elif level == "moderate":
        for i in words:
            if i in sw2 or i in punctuations:
                del i
            else:
                new_words.append(i)
        return new_words

    elif level == "hard":
        for i in words:
            if i in sw3 or i in punctuations:
                del i
            else:
                new_words.append(i)
        return new_words

    else:
        return None

